BUFF_FLASH_TIME = 0.75;
BUFF_ALPHA_VALUE = 1;
BUFF_MAX_ALPHA = 1.2;
BUFF_MIN_ALPHA = 0.3;

YELLOW_FONT_COLOR = {r=1.0, g=1.0, b=0.1};

function SUI_PlayerBuffButton_Update(this)
	local name, texture, count;
	if (this.debuff) then
		name, texture, count = UnitDebuff("player", this:GetID());
		local i = 1;
		while UnitBuff("player",i) ~= nil do
			i = i + 1;
		end
		if this:GetName() == "SUI_PlayerDebuffButton1" then
			this:ClearAllAnchors();
			this:SetAnchor("TOPLEFT", "TOPLEFT", "SUI_PlayerBuffFrame", 0, (i - 1) * 20);
		end
	else
		name, texture, count = UnitBuff("player", this:GetID());
	end
	if (not name) then
		this:Hide();
	else
		if (count < 1) then
			count = "";
		end
		getglobal(this:GetName().."Icon"):SetTexture(texture);
		getglobal(this:GetName().."Count"):SetText(count);
		this:SetAlpha(1.0);
		this:Show();
	end
	
	if (GameTooltip:IsOwned(this)) then
		if (this.debuff) then
			GameTooltip:SetUnitDebuff("player", this:GetID());
		else
			GameTooltip:SetUnitBuff("player", this:GetID());
		end
	end
	
	SUI_PlayerBuffButton_OnUpdate(this);
end

function SUI_PlayerBuffButton_OnLoad(this)
	this:RegisterForClicks("RightButton");
	this:RegisterEvent("UNIT_BUFF_CHANGED");
	
	SUI_PlayerBuffButton_Update(this);
end

function SUI_PlayerBuffButton_OnEvent(this, event)
	if (event == "UNIT_BUFF_CHANGED") then
		if (arg1 == "player") then
			SUI_PlayerBuffButton_Update(this);
		end
	end
end

function SUI_PlayerBuffButton_OnUpdate(this, elapsedTime)
	local leftTime;
	if (this.debuff) then
		leftTime = UnitDebuffLeftTime("player", this:GetID());
	else
		leftTime = UnitBuffLeftTime("player", this:GetID());
		if (leftTime and leftTime < BUFF_DURATION_WARNING_TIME) then
			this:SetAlpha(BUFF_ALPHA_VALUE);
		else
			this:SetAlpha(1.0);
		end
	end
	SUI_BuffFrame_UpdateDuration(this, leftTime);
end

function SUI_BuffFrame_UpdateDuration(this, leftTime)
	local duration = getglobal(this:GetName().."Duration");
	if (leftTime) then
		duration:SetText(SecondsToTimeAbbrev(leftTime));
		if (this.debuff) then
			duration:SetColor(RED_FONT_COLOR.r, RED_FONT_COLOR.g, RED_FONT_COLOR.b);
		else
			duration:SetColor(YELLOW_FONT_COLOR.r, YELLOW_FONT_COLOR.g, YELLOW_FONT_COLOR.b);
		end
		duration:Show();
	else
		duration:Hide();
	end
end

function SUI_PlayerBuffFrame_OnLoad(this)
	BUFF_ALPHA_VALUE = 1;
	BUFF_FLASH_STATE = 1;
end

function SUI_PlayerBuffFrame_OnUpdate(this, elapsedTime)
	if ( BUFF_FLASH_STATE ) then
		BUFF_ALPHA_VALUE = BUFF_ALPHA_VALUE - elapsedTime * BUFF_FLASH_TIME;
		if ( BUFF_ALPHA_VALUE < BUFF_MIN_ALPHA ) then
			BUFF_ALPHA_VALUE = BUFF_MIN_ALPHA;
			BUFF_FLASH_STATE = nil;
		end
	else
		BUFF_ALPHA_VALUE = BUFF_ALPHA_VALUE + elapsedTime * BUFF_FLASH_TIME;
		if ( BUFF_ALPHA_VALUE > BUFF_MAX_ALPHA ) then
			BUFF_ALPHA_VALUE = BUFF_MAX_ALPHA;
			BUFF_FLASH_STATE = 1;
		end
	end
end