SUI_UnitRelationColor = {}
SUI_UnitRelationColor[1] = { r = 1.00, g = 0.00, b = 0.00 };
SUI_UnitRelationColor[2] = { r = 1.00, g = 0.50, b = 0.00 };
SUI_UnitRelationColor[3] = { r = 1.00, g = 1.00, b = 0.00 };
SUI_UnitRelationColor[4] = { r = 0.00, g = 1.00, b = 0.00 };
SUI_UnitRelationColor[5] = { r = 0.00, g = 0.50, b = 1.00 };

MAX_TARGET_BUFFS = 16;
MAX_TARGET_DEBUFFS = 16;
MAX_TARGET_BUFF_LINES = 8;
MAX_TARGET_DEBUFF_LINES = 8;
MAX_TARGET_BUFFS_SIZE = 20;

function SUI_TargetBuffButton_Update()
	local x = 0;
	local y = 1;
	for i = 1, MAX_TARGET_BUFFS do
		local button = getglobal("SUI_TargetBuffButton"..i);
		local name, texture, count = UnitBuff("target", i);
		if (name) then
			if (count < 1) then
				count = "";
			end
			getglobal(button:GetName().."Icon"):SetTexture(texture);
			getglobal(button:GetName().."Count"):SetText(count);
			if (i == 1) then
				button:ClearAllAnchors();
				button:SetAnchor("TOPLEFT", "BOTTOMLEFT", "SUI_TargetFrame", x, y);
				y = y + MAX_TARGET_BUFFS_SIZE;
			elseif (i == 8) then
				y = y + MAX_TARGET_BUFFS_SIZE;
			end
			button:Show();
		else
			button:Hide();
		end
	end
	
	for i = 1, MAX_TARGET_DEBUFFS do
		local button = getglobal("SUI_TargetDebuffButton"..i);
		local name, texture, count = UnitDebuff("target", i);
		if (name) then
			if (count < 1) then
				count = "";
			end
			getglobal(button:GetName().."Icon"):SetTexture(texture);
			getglobal(button:GetName().."Count"):SetText(count);
			if (i == 1) then
				button:ClearAllAnchors();
				button:SetAnchor("TOPLEFT", "BOTTOMLEFT", "SUI_TargetFrame", x, y);
			end
			button:Show();
		else
			button:Hide();
		end
	end
end

function SUI_TargetFrame_Update(this)
	if (UnitExists("target")) then
		SUI_UnitFrame_Update(this);
		SUI_TargetBuffButton_Update();
		SUI_TargetFrameRelation_Update();
		this:Show();
	else
		this:Hide();
	end
end

function SUI_TargetFrameRelation_Update()
	local r, g, b;
	if (UnitCanAttack("target", "player")) then
		if (UnitCanAttack("player", "target")) then
			r = SUI_UnitRelationColor[1].r;
			g = SUI_UnitRelationColor[1].g;
			b = SUI_UnitRelationColor[1].b;
		else
			r = SUI_UnitRelationColor[2].r;
			g = SUI_UnitRelationColor[2].g;
			b = SUI_UnitRelationColor[2].b;
		end
	elseif (UnitCanAttack("player", "target")) then
		r = SUI_UnitRelationColor[3].r;
		g = SUI_UnitRelationColor[3].g;
		b = SUI_UnitRelationColor[3].b;
	elseif (UnitInParty("target")) then
		r = SUI_UnitRelationColor[5].r;
		g = SUI_UnitRelationColor[5].g;
		b = SUI_UnitRelationColor[5].b;
	else
		r = SUI_UnitRelationColor[4].r;
		g = SUI_UnitRelationColor[4].g;
		b = SUI_UnitRelationColor[4].b;
	end
	SUI_TargetFrameName:SetColor(r, g, b);
end

function SUI_TargetFrame_OnLoad(this)
	SUI_UnitFrame_Initialize(this, "target", 
		SUI_TargetFrameName, SUI_TargetFramePortrait, 
		SUI_TargetFrameHealthBar, SUI_TargetFrameManaBar, 
		SUI_TargetFrameSkillBar, SUI_TargetRaidTargetFrame);

	this:RegisterForClicks("LeftButton", "RightButton");
	this:RegisterEvent("UNIT_TARGET_CHANGED");
	this:RegisterEvent("UNIT_BUFF_CHANGED");
	this:RegisterEvent("UNIT_CLASS_CHANGED");
	this:RegisterEvent("UNIT_RELATION");	
	
	SUI_TargetFramePortrait:ClearAllAnchors();
	SUI_TargetFramePortrait:SetAnchor("LEFT", "RIGHT", "SUI_TargetFrame", 2, 0);
	SUI_TargetFramePortraitBorder:ClearAllAnchors();
	SUI_TargetFramePortraitBorder:SetAnchor("CENTER", "CENTER", "SUI_TargetFramePortrait", 0, 0);
	SUI_TargetFrame_Update(this);
end

function SUI_TargetFrame_OnEvent(this, event, arg1, arg2)
	SUI_UnitFrame_OnEvent(this, event, arg1, arg2);
	if (event == "UNIT_TARGET_CHANGED") then
		if (arg1 == "player") then
			TutorialFrame_OnTargetChange();
			SUI_TargetCastingBar_Update();
			SUI_TargetFrame_Update(this);
		elseif (arg1 == "target") then
			SUI_TargetFrame_Update(this);
		end
	elseif (event == "UNIT_BUFF_CHANGED") then
		if (arg1 == "target") then			
			SUI_TargetBuffButton_Update();
		end
	end
end

function SUI_TargetFrame_OnShow(this)
end

function SUI_TargetFrame_OnHide(this)
	CloseDropDownMenus();
	SUI_CloseTargetCastingBar();
	if (this.target) then
		this.target:Hide();
	end
end

function SUI_TargetFrame_OnClick(this, key)
	if (SpellIsTargeting() and key == "RBUTTON") then
		SpellStopCasting();
		return;
	end
	
	if ( key == "LBUTTON" ) then
		if ( SpellIsTargeting() ) then
			SpellTargetUnit("target");
		elseif ( CursorHasItem() ) then
			DropItemOnUnit("target");
		end
	else
		ToggleDropDownMenu(TargetFrameDropDown, 1, nil, "SUI_TargetFrame", -2,0);
	end
end

function SUI_TargetCastingBar_OnLoad(this)
	this:RegisterEvent("UNIT_CASTINGTIME");
end

function SUI_TargetCastingBar_OnEvent(this, event)
	if (event == "UNIT_CASTINGTIME") then
		if (arg1 == "target") then
			local name, maxValue, currValue = UnitCastingTime("target");
			if (name) then
				SUI_TargetCastingBarText:SetText(name);
				this.fadeOut = 1;
				this.maxValue = maxValue;
				this:SetBarColor(0.0, 1.0, 0.0);
				this:SetMinValue(0);
				this:SetMaxValue(maxValue);
				this:SetValue(currValue);
				this:SetAlpha(1);
				this:Show();
			else
				this.maxValue = nil;
			end
			SUI_TargetCastingBar_SetAnchor();
		end
	end
end

function SUI_TargetCastingBar_Update()
	local name, maxValue, currValue = UnitCastingTime("target");
	if (name) then
		SUI_TargetCastingBarText:SetText(name);
		SUI_TargetCastingBar.fadeOut = 1;
		SUI_TargetCastingBar.maxValue = maxValue;
		SUI_TargetCastingBar:SetBarColor(0.0, 1.0, 0.0);
		SUI_TargetCastingBar:SetMinValue(0);
		SUI_TargetCastingBar:SetMaxValue(maxValue);
		SUI_TargetCastingBar:SetValue(currValue);
		SUI_TargetCastingBar:SetAlpha(1);
		SUI_TargetCastingBar:Show();
	elseif SUI_TargetCastingBar:IsVisible() then
		SUI_CloseTargetCastingBar();
	end
end

function SUI_TargetCastingBar_OnUpdate(this, elapsedTime)
	if (this.maxValue) then
		local currTime = this:GetValue() + elapsedTime;
		if (currTime > this.maxValue) then
			currTime = this.maxValue;
		end
		this:SetValue(currTime);

		local sparkPosition = currTime / this.maxValue * 156;
		if (sparkPosition < 0) then
			sparkPosition = 0;
		end
		SUI_TargetCastingBarSpark:ClearAllAnchors();
		SUI_TargetCastingBarSpark:SetAnchor("CENTER", "LEFT", SUI_TargetCastingBarSpark, sparkPosition, 0);
	elseif (this.fadeOut) then
		local alpha = this:GetAlpha() - elapsedTime;
		if (alpha > 0) then
			this:SetAlpha(alpha);
		else
			SUI_CloseTargetCastingBar();
		end
	end
end

function SUI_CloseTargetCastingBar()
	SUI_TargetCastingBar.maxValue = nil;
	SUI_TargetCastingBar.fadeOut = nil;
	SUI_TargetCastingBar:Hide();
end

function SUI_TargetCastingBar_SetAnchor()
	local y = 3;
	local i = 1;
	while UnitBuff("target", i) ~= nil do
		if (i == 1) then
			y = y + MAX_TARGET_BUFFS_SIZE;
		elseif (i == 9) then
			y = y + MAX_TARGET_BUFFS_SIZE;
		end
		i = i + 1;
	end
	local i = 1;
	while UnitDebuff("target", i) ~= nil do
		if (i == 1) then
			y = y + MAX_TARGET_BUFFS_SIZE;
		elseif (i == 9) then
			y = y + MAX_TARGET_BUFFS_SIZE;
		end
		i = i + 1;
	end
	SUI_TargetCastingBar:ClearAllAnchors();
	SUI_TargetCastingBar:SetAnchor("TOP", "BOTTOM", "SUI_TargetFrame", 0, y);
end